
void PGA2311_init() {
  pinMode(CS_pin, OUTPUT);        //Make chip select line an output
  digitalWrite(CS_pin, HIGH);     //CS = off
  pinMode(Mute_pin, OUTPUT);      //Make Mute line an output
  digitalWrite(Mute_pin, HIGH);   //Mute = off
  pinMode(SDI_pin, OUTPUT);       //Make SDI line an output
  digitalWrite(SDI_pin, LOW);     //SDI =  = 0
  pinMode(SCLK_pin, OUTPUT);      //Make SCLK line an output
  digitalWrite(SCLK_pin, LOW);    //Clock = 0
}


void Mute() {
  digitalWrite(Mute_pin, LOW);   //Mute = on (active low)
  muted = true;
}

void unMute() {
  digitalWrite(Mute_pin, HIGH);   //Mute = off
  muted = false;
}


void PGA2311_vol(byte spkr_offset) {
  //for now, vol_left = vol_right
  unMute();
  byte offset;
  byte vol_left;
  byte vol_right;
  /* maximum volume value is vol_value_qty.  This corresponds to vol_value_max, which is +10db
   * So the maximum value corresponds to an "N" of  255 - (31.5 - vol_value_max) * 2, or 192 + 2 * vol_val_max
   * So in order to make the maximum value = 10db, we need to multiply the vol_value_qty by 2 and add enough to equal that N
   * The offset we need to add is:  (192 + 2 * vol_val_max) - (vol_value_qty -1) * 2
   */
  
  vol_left = Master_vol + spkr_offset;
  vol_right = Master_vol + spkr_offset;
  PGA2311_write(vol_left, vol_right);
}

void PGA2311_write(byte vol_left, byte vol_right) {
  digitalWrite(CS_pin, LOW);     //CS = on
  PGA2311_byteout(vol_right);
  PGA2311_byteout(vol_left);
  digitalWrite(CS_pin, HIGH);    //CS = off
}

void PGA2311_byteout(byte vol) {
  byte mask = 0x80;
  for (int i = 0; i < 8; i++) {
    if (vol & mask)  digitalWrite(SDI_pin, HIGH);
    else digitalWrite(SDI_pin, LOW);
    digitalWrite(SCLK_pin, HIGH);
    mask >>= 1;                      //delay and prepare for next bit
//lcd.clear();
//lcd.print(mask,HEX); lcd.print(" "); lcd.print(vol,HEX);
//delay(1000);
    
    digitalWrite(SCLK_pin, LOW);
  }
}


